<script lang="ts" setup>
import type { BaseCopy, BaseCTA } from '@/types/base';

// TODO: Remove icons when the SlpIcon is fully functional
import { Target, DAndI, SpeedAlt2, UserCollaboration, ChevronLgRight } from 'slippers-ui/icons';

const icons = {
  target: Target,
  'd-and-i': DAndI,
  'speed-alt-2': SpeedAlt2,
  'user-collaboration': UserCollaboration,
};

interface TeamOpsCardSection extends BaseCopy {
  cards: Array<
    BaseCTA & {
      config?: {
        color?: string;
        icon?: string;
      };
    }
  >;
}

defineProps<TeamOpsCardSection>();

const dataAOS = ref({
  animation: 'fade-up',
  duration: 1600,
  offset: 200,
});
</script>
<template>
  <section class="team-ops-card-section">
    <SlpContainer>
      <SlpTypography
        variant="heading2-bold"
        tag="h2"
        :data-aos="dataAOS.animation"
        :data-aos-duration="dataAOS.duration"
        :data-aos-offset="dataAOS.offset"
        >{{ title }}</SlpTypography
      >
      <SlpTypography
        variant="heading5-bold"
        tag="h3"
        class="slp-mt-48"
        :data-aos="dataAOS.animation"
        :data-aos-duration="dataAOS.duration"
        :data-aos-offset="dataAOS.offset"
        >{{ subTitle }}</SlpTypography
      >
      <SlpRow class="slp-mt-48">
        <SlpColumn
          v-for="(card, index) in cards"
          :key="index"
          :cols="6"
          class="team-ops-card-section__column slp-pb-32"
        >
          <a
            :href="card.link.href"
            :data-ga-name="card.link.config.dataGaName || card.title.toLowerCase()"
            :data-ga-location="card.link.config.dataGaLocation || 'principals'"
          >
            <div
              class="team-ops-card-section__card"
              :data-aos="dataAOS.animation"
              :data-aos-duration="dataAOS.duration"
              :data-aos-offset="dataAOS.offset"
            >
              <div class="team-ops-card-section__card__bar" :style="{ background: card.config.color }"></div>
              <div class="team-ops-card-section__card__content slp-py-48 slp-px-48">
                <SlpIcon :icon="icons[card.config.icon]" :alt="card.config.icon" size="md" />
                <SlpTypography variant="heading5-bold" tag="h3" class="slp-mt-8">{{ card.title }}</SlpTypography>
                <SlpTypography variant="body1" tag="p" class="slp-mt-24 slp-mb-48">{{
                  card.description
                }}</SlpTypography>
                <SlpButton
                  v-if="card.link"
                  :href="card.link.config?.href"
                  variant="tertiary"
                  :data-ga-name="card.link.config?.dataGaName || card.title"
                  :data-ga-location="card.link.config?.dataGaLocation || 'principals'"
                  class="team-ops-card-section__card__button"
                >
                  {{ card.link.text }}
                  <SlpIcon class="slp-ml-8" :icon="ChevronLgRight" variant="product" alt="Chevron Right Icon" />
                </SlpButton>
              </div>
            </div>
          </a>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.team-ops-card-section {
  padding: $spacing-48 0 0 0;
  @media (min-width: $breakpoint-md) {
    padding: $spacing-96 0 0 0;
  }

  &__column {
    @media (min-width: $breakpoint-md) {
      &:nth-child(odd) {
        padding-right: $spacing-32;
      }
    }
  }

  &__card {
    height: 100%;
    &__content {
      position: relative;
      height: 100%;
      color: $color-text-300;
      display: flex;
      flex-direction: column;
      border: 2px solid $color-primary-200;
      border-top: 0 solid transparent;
      border-radius: 0 0 $spacing-16 $spacing-16;
    }

    &__bar {
      border-radius: $spacing-8 $spacing-8 0 0;
      height: $spacing-8;
      width: 100%;
      position: relative;
      left: 0;
      top: 0;
    }

    &__button {
      margin: auto 0 0 0;
      padding-left: 0;
      padding-bottom: 0;
    }
  }
}
</style>
